mod Ex02a

incl Mtex

loc rem 
  \para \bf  2. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21.2 
  \para* \it  Dátum:  \end pondelok 20.2.2023 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/2223ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para celočíselná odmocnina (názorný príklad), 
   \item \para Cantorova párovacia funkcia a aritmetizácia karteziánskeho 
         súčinu, 
   \item \para Catalanova párovacia funkcia. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 1 
   \item \para Počet bodov za prémiove úlohy v tomto súbore: 0 
  \end
  \para Odovzdať do 25.2.2023 (sobota). 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Online. 
   \item \para \it  [2]  \end Ján Kľuka. Úvod do deklaratívneho 
         programovania. Online. 
   \item \para \it  [3]  \end Ján Komara. Recursive Functions. Online. 
  \end

rem 
  \para \bf  [CL] Remark.  \end Note that the square function 
  \def 
    fun Sq 'Tex_f1_n_sq'
    Sq(x) = x*x
  \end
  \para is defined in the included module \it  Standard  \end. 

rem 
  \para \bf  Integer Square Root (case study).  \end Specification: 
  \eq* 
    Sq Tex_f1_n_sqrt(x) <= x & x < Sq(Tex_f1_n_sqrt(x)+1)
  \end

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Primitive Recursion.  \end 

rem 
  \para \bf  Square root function.  \end 

fun Sqrt1 'Tex_f1_n_sqrt'
  Sqrt1(x) = Foo

rem 
  \para \bf  Square root with assignments.  \end 

fun Sqrt2 'Tex_f1_n_sqrt'
  Sqrt2(x) = Foo

rem 
  \para \bf  Section. Course of Values Recursion.  \end 

rem 
  \para \bf  Subsection. Course of Values Recursion with Measure.  \end 

rem 
  \para \bf  Bottom up program for the square root function.  \end 

fun/2 F3 'Tex_f2_f'
  F3(x,y) = Foo

rem 
  \para Invariant 
  \eq* 
    Sq(y) <= x -> Sq F3(x,y) <= x & x < Sq(F3(x,y)+1)
  \end

fun Sqrt3 'Tex_f1_n_sqrt'
  Sqrt3(x) = Foo

rem 
  \para \bf  Section. Recursion on Notation.  \end 

rem 
  \para \bf  Subsection. \ft p \end-ary arithmetic.  \end 

rem 
  \para \bf  A fast program for the square root function. \it  (1 point)  \end 
   \end 

fun Sgn 'Tex_f1_n_sgn'
  Sgn(0) = 0
  Sgn(x) = 1 <- x != 0

fun Sqrt4 'Tex_f1_n_sqrt'
  Sqrt4(x) = Foo <- x = 4*y+z & 0 <= z & z <= 3

